package betterwithmods.client.model.generators;

import betterwithmods.library.utils.BannerUtils;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;

public abstract class ModelRadialBlades extends ModelBase {

    public final int bladeCount;
    private BannerUtils.BannerData[] banners;
    private ModelPart base;

    public ModelRadialBlades(int bladeCount) {
        this.bladeCount = bladeCount;
        this.base = new ModelPart(this, 0, 0);
        for (int i = 0; i < bladeCount; i++) {
            base.func_78792_a(createBlade(i));
        }
        banners = new BannerUtils.BannerData[this.bladeCount];
    }

    protected abstract ModelPart createBlade(int index);

    public void setAngle(double x, double y, double z) {
        this.base.setRotateAngle(x, y, z);
    }

    public void render(float scale) {
        if (this.base.field_78805_m != null) {
            int i = 0;
            for (ModelRenderer r1 : this.base.field_78805_m) {
                if (r1.field_78805_m != null) {
                    for (ModelRenderer r2 : r1.field_78805_m) {
                        ModelPart r = (ModelPart) r2;
                        if (r.hasBanner()) {
                            r.setBanner(banners[i]);
                            i++;
                        }
                    }
                }
            }
        }
        this.base.func_78785_a(scale);
    }

    public void setBanner(int index, BannerUtils.BannerData data) {
        this.banners[index] = data;
    }

}
