package betterwithmods.client.tesr;

import betterwithmods.client.model.generators.ModelHorizontalWindmill;
import betterwithmods.client.model.render.RenderUtils;
import betterwithmods.common.tile.TileWindmillHorizontal;
import betterwithmods.lib.ModLib;
import betterwithmods.library.utils.BannerUtils;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;

import javax.annotation.Nullable;

public class TESRWindmill extends TileEntitySpecialRenderer<TileWindmillHorizontal> {
    public static final ResourceLocation WINDMILL_FRAME = new ResourceLocation(ModLib.MODID, "textures/blocks/windmills/horizontal_frame.png");
    public static final ResourceLocation WINDMILL_SAIL = new ResourceLocation(ModLib.MODID, "textures/blocks/windmills/sail.png");
    private static ModelHorizontalWindmill render = new ModelHorizontalWindmill();

    public static void renderWindmill(float direction, float rotation, double x, double y, double z, float alpha, @Nullable BannerUtils.BannerData[] data) {
        GlStateManager.func_179094_E();
        GlStateManager.func_179091_B();
        GlStateManager.func_179137_b(x + 0.5D, y + 0.5D, z + 0.5D);
        GlStateManager.func_179114_b(direction, 0.0F, 1.0F, 0.0F);
        if (data != null) {
            for (int i = 0; i < data.length; i++) {
                render.setBanner(i, data[i]);
            }
        }
        render.setAngle(0, 0, -(float) Math.toRadians(rotation));
        render.render(0.0625F);

        GlStateManager.func_179121_F();
        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, alpha);
    }

    @Override
    public void func_192841_a(TileWindmillHorizontal te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        BlockPos pos = te.getBlockPos();
        RenderUtils.renderDebugBoundingBox(x, y, z, te.getRenderBoundingBox().func_72317_d(-pos.func_177958_n(), -pos.func_177956_o(), -pos.func_177952_p()));
        EnumFacing facing = te.getOrientation();
        float rotation = (te.getCurrentRotation() + (te.getMechanicalOutput(facing) == 0 ? 0 : partialTicks * te.getPrevRotation()));
        renderWindmill((facing == EnumFacing.SOUTH ? 180 : 90f), rotation, x, y, z, alpha, te.getData());
    }


}
