package betterwithmods.common.blocks.camo;

import betterwithmods.client.baking.IRenderComparable;
import betterwithmods.common.tile.TileDynamic;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;

public class CamoInfo implements IRenderComparable<CamoInfo> {
    private final IBlockState state;

    public CamoInfo(IBlockState state) {
        this.state = state;
    }

    public CamoInfo(ItemStack stack) {
        NBTTagCompound tag = stack.func_77978_p();
        if (tag != null && tag.func_74764_b("texture")) {
            this.state = NBTUtil.func_190008_d(tag.func_74775_l("texture"));
        } else {
            this.state = Blocks.field_150350_a.func_176223_P();
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CamoInfo cacheInfo = (CamoInfo) o;
        return !state.equals(cacheInfo.state);
    }

    @Override
    public boolean renderEquals(CamoInfo other) {
        return equals(other);
    }

    @Override
    public int renderHashCode() {
        return state.hashCode();
    }


    public IBlockState getState() {
        if (state == null)
            return Blocks.field_150350_a.func_176223_P();
        return state;
    }
}
