package betterwithmods.common.registry.advanceddispenser;

import betterwithmods.BetterWithMods;
import betterwithmods.lib.ModLib;
import betterwithmods.library.utils.DirUtils;
import betterwithmods.module.general.General;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.dispenser.BehaviorDefaultDispenseItem;
import net.minecraft.dispenser.IBlockSource;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.*;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraftforge.common.util.FakePlayer;
import net.minecraftforge.common.util.FakePlayerFactory;

import javax.annotation.Nonnull;

public class BehaviorDefaultDispenseBlock extends BehaviorDefaultDispenseItem {

    public ItemStack getInputStack(IBlockSource source, ItemStack stackIn) {
        return stackIn;
    }


    @Nonnull
    @Override
    protected ItemStack func_82487_b(IBlockSource source, ItemStack stackIn) {
        EnumFacing facing = source.func_189992_e().func_177229_b(DirUtils.FACING);

        BlockPos check = source.func_180699_d().func_177972_a(facing);
        ItemStack stack = getInputStack(source, stackIn);

        World world = source.func_82618_k();

        FakePlayer fake = FakePlayerFactory.get((WorldServer) world, ModLib.ADVANCED_DISPENSER);
        fake.func_184611_a(EnumHand.MAIN_HAND, stack);
        DirUtils.setEntityOrientationFacing(fake, facing.func_176734_d());

        if (General.isDebug())
            BetterWithMods.LOGGER.debug("Better With Mods FakePlayer ID: " + fake.func_110124_au());

        if (!world.func_175623_d(check) && !world.func_180495_p(check).func_177230_c().func_176200_f(world, check))
            return ItemStack.field_190927_a;

        Item item = stack.func_77973_b();

        if (item instanceof ItemBlock && canPlaceBlockOnSide((ItemBlock) item, world, check, facing, fake, stack)) {
            ItemBlock itemblock = (ItemBlock) item;
            Block block = ((ItemBlock) item).func_179223_d();
            boolean blockAcross = !world.func_175623_d(check.func_177972_a(facing));
            IBlockState state = block.getStateForPlacement(world, check, facing, getX(facing, blockAcross), getY(facing, blockAcross), getZ(facing, blockAcross), stack.func_77952_i(), fake, fake.func_184600_cs());
            if (block.func_176196_c(world, check)) {
                if (itemblock.placeBlockAt(stack, fake, world, check, facing, getX(facing, blockAcross), getY(facing, blockAcross), getZ(facing, blockAcross), state)) {
                    world.func_184133_a(null, check, state.func_177230_c().getSoundType(state, world, check, fake).func_185841_e(), SoundCategory.BLOCKS, 0.7F, 1.0F);
                    stackIn.func_190918_g(1);
                    return stack.func_190926_b() ? ItemStack.field_190927_a : stack;
                }
            }
        } else if (item instanceof ItemBlockSpecial && item.func_180614_a(fake, world, check, EnumHand.MAIN_HAND, facing, 0.1F, 0.0F, 0.1F) == EnumActionResult.SUCCESS) {
            stack.func_190918_g(1);
            return stack.func_190926_b() ? ItemStack.field_190927_a : stack;

        } else if (item instanceof ItemSeeds && item.func_180614_a(fake, world, check.func_177977_b(), EnumHand.MAIN_HAND, EnumFacing.UP, 0.1F, 0.0F, 0.1F) == EnumActionResult.SUCCESS) {
            stack.func_190918_g(1);
            return stack.func_190926_b() ? ItemStack.field_190927_a : stack;
        } else {
            super.func_82487_b(source, stack);
        }
        return ItemStack.field_190927_a;
    }

    private float getX(EnumFacing facing, boolean blockAcross) {
        return facing == EnumFacing.NORTH && blockAcross ? 0.9F : 0.1F;
    }

    private float getY(EnumFacing facing, boolean blockAcross) {
        return facing == EnumFacing.UP && blockAcross ? 0.9F : 0.1F;
    }

    private float getZ(EnumFacing facing, boolean blockAcross) {
        return facing == EnumFacing.WEST && blockAcross ? 0.9F : 0.1F;
    }

    private boolean canPlaceBlockOnSide(ItemBlock itemBlock, World worldIn, BlockPos pos, EnumFacing side, EntityPlayer player, ItemStack stack) {
        Block block = worldIn.func_180495_p(pos).func_177230_c();

        if (block == Blocks.field_150431_aC && block.func_176200_f(worldIn, pos)) {
            side = EnumFacing.UP;
        } else if (!block.func_176200_f(worldIn, pos)) {
            pos = pos.func_177972_a(side);
        }

        return worldIn.func_190527_a(itemBlock.func_179223_d(), pos, false, side, null);
    }
}
