package betterwithmods.module.general;

import betterwithmods.library.common.modularity.impl.RequiredModule;
import betterwithmods.module.general.moreheads.MoreHeads;
import betterwithmods.module.internal.UnitTesting;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;

public class General extends RequiredModule {

    private static boolean debug;

    public static boolean isDebug() {
        return debug;
    }

    @Override
    public void setup() {
        addFeatures(
                new Client(),
                new Waterwheel(),
                new MechanicalPower(),
                new Hemp(),
                new MoreCobble(),
                new FluidBottles(),
                new UnitTesting(),
                new Pulley(),
                new MoreHeads(),
                new InfernalEnchanting()
        );
    }

    @Override
    public void onPreInit(FMLPreInitializationEvent event) {
        debug = config().load(getName(), "Debug Mode", false).setComment("Log extra debug information, warning can spam logs").get();
        super.onPreInit(event);
    }
}
