package betterwithmods.module.general.moreheads.client;

import net.minecraft.client.Minecraft;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.util.ResourceLocation;

import javax.annotation.Nonnull;

public class RenderHeadModel<M extends ModelBase> implements IRenderHead<M> {

    protected static final TextureManager manager = Minecraft.func_71410_x().func_110434_K();

    @Nonnull
    protected M model;
    @Nonnull
    private ResourceLocation texture;

    public RenderHeadModel(@Nonnull M model, @Nonnull ResourceLocation texture) {
        this.model = model;
        this.texture = texture;
    }

    @Override
    public M getModel() {
        return model;
    }

    @Override
    public ResourceLocation getTexture() {
        return texture;
    }

    @Override
    public void render(double x, double y, double z, float partialTicks, float rotation) {
        manager.func_110577_a(getTexture());
        GlStateManager.func_179094_E();

        GlStateManager.func_179129_p();
        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179091_B();
        GlStateManager.func_179152_a(-1.0F, -1.0F, 1.0F);
        GlStateManager.func_179141_d();
        getModel().func_78088_a(null, partialTicks, 0.0F, 0.0F, rotation, 0.0F, getScale());
        GlStateManager.func_179089_o();
        GlStateManager.func_179121_F();
    }

    public void setLightmap() {
        int i = 15728640;
        int j = i % 65536;
        int k = i / 65536;
        OpenGlHelper.func_77475_a(OpenGlHelper.field_77476_b, (float) j, (float) k);
    }

    public float getScale() {
        return 0.0625f;
    }
}
