package betterwithmods.module.hardcore.world.structures;

import com.google.common.collect.Sets;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureComponent;

import java.util.Set;

public class RelativePosChanger implements IChanger {
    private Set<BlockPos> check;
    private IBlockState state;

    public RelativePosChanger(IBlockState state, AxisAlignedBB box) {
        this.check = Sets.newHashSet(getPosInBox(box));
        this.state = state;
    }

    public RelativePosChanger(IBlockState state, BlockPos... positions) {
        this.check = Sets.newHashSet(positions);
        this.state = state;
    }

    public static Iterable<BlockPos> getPosInBox(AxisAlignedBB box) {
        return BlockPos.func_177980_a(new BlockPos((int) box.field_72340_a, (int) box.field_72338_b, (int) box.field_72339_c), new BlockPos((int) (box.field_72336_d), (int) (box.field_72337_e), (int) (box.field_72334_f)));
    }

    @Override
    public boolean canChangeState(StructureComponent structure, World world, BlockPos pos, BlockPos relativePos, IBlockState original) {
        return check.contains(relativePos);
    }

    @Override
    public IBlockState changeState(StructureComponent structure, World world, BlockPos pos, BlockPos relativePos, IBlockState original) {
        return state;
    }

    @Override
    public boolean canChangeLoot(StructureComponent structure, World world, BlockPos pos, ResourceLocation lootTable) {
        return false;
    }

    @Override
    public ResourceLocation changeLootTable(StructureComponent structure, World world, BlockPos pos, ResourceLocation lootTable) {
        return null;
    }
}
