package betterwithmods.module.internal.player;

import betterwithmods.BetterWithMods;
import betterwithmods.lib.ModLib;
import betterwithmods.library.common.modularity.impl.RequiredFeature;
import betterwithmods.module.hardcore.needs.HCNames;
import betterwithmods.module.internal.AdvancementRegistry;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.scoreboard.Scoreboard;
import net.minecraft.scoreboard.Team;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.common.capabilities.CapabilityManager;
import net.minecraftforge.event.AttachCapabilitiesEvent;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;


public class PlayerDataHandler extends RequiredFeature {

    //TODO better way to handle the team.
    public static final String TEAM = "BWMTeam";

    private static final ResourceLocation PLAYER_INFO = new ResourceLocation(ModLib.MODID, "player_info");

    @SubscribeEvent
    public void clone(PlayerEvent.Clone event) {
        PlayerInfo o = PlayerInfo.getPlayerInfo(event.getOriginal());
        PlayerInfo n = PlayerInfo.getPlayerInfo(event.getEntityPlayer());
        if (o != null && n != null) {
            n.deserializeNBT(o.serializeNBT());
        }
    }

    @SubscribeEvent
    public void attachCapability(AttachCapabilitiesEvent<Entity> event) {
        if (event.getObject() instanceof EntityPlayer && !event.getCapabilities().containsKey(PLAYER_INFO)) {
            event.addCapability(PLAYER_INFO, new PlayerInfo());
        }
    }

    @Override
    public void onPreInit(FMLPreInitializationEvent event) {
        CapabilityManager.INSTANCE.register(PlayerInfo.class, new PlayerInfo.Storage(), PlayerInfo::new);
    }

    @SuppressWarnings("ConstantConditions")
    @Override
    public void onServerStarting(FMLServerStartingEvent event) {
        Scoreboard scoreboard = event.getServer().func_130014_f_().func_96441_U();
        if (scoreboard.func_96508_e(TEAM) == null)
            scoreboard.func_96527_f(TEAM);
        scoreboard.func_96508_e(TEAM).func_178772_a(BetterWithMods.MODULE_LOADER.isFeatureEnabled(HCNames.class) ? Team.EnumVisible.NEVER : Team.EnumVisible.ALWAYS);
    }

    @Override
    public String getDescription() {
        return "Internal handler for PlayerInfo capability";
    }


    @SubscribeEvent
    public void onPlayerDeath(LivingDeathEvent event) {
        if(event.getEntityLiving() instanceof EntityPlayerMP) {
            EntityPlayerMP player = (EntityPlayerMP) event.getEntityLiving();
            AdvancementRegistry.STATE_TRIGGER.trigger(player, "player_death");
        }
    }

}
