package betterwithmods.module.recipes.miniblocks;

import betterwithmods.common.blocks.camo.BlockDynamic;
import betterwithmods.common.tile.TileDynamic;
import net.minecraft.advancements.CriteriaTriggers;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentTranslation;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

public class ItemCamo extends ItemBlock {

    public ItemCamo(Block block) {
        super(block);
        func_77627_a(true);
    }

    public static IBlockState getState(ItemStack stack) {
        if (stack != null && stack.func_77973_b() instanceof ItemCamo) {
            NBTTagCompound tag = stack.func_179543_a("texture");
            if (tag != null) {
                return NBTUtil.func_190008_d(tag);
            }
        }
        return null;
    }

    public static boolean matches(ItemStack a, ItemStack b) {
        if ((a == null || b == null))
            return false;
        if (!(a.func_77973_b() instanceof ItemCamo && b.func_77973_b() instanceof ItemCamo))
            return false;

        ItemCamo miniA = (ItemCamo) a.func_77973_b(), miniB = (ItemCamo) b.func_77973_b();
        if (miniA.func_179223_d() != miniB.func_179223_d())
            return false;
        IBlockState stateA = getState(a), stateB = getState(b);
        return stateA != null & stateB != null && stateA.equals(stateB);
    }

    public static boolean placeBlockAt(ItemCamo item, ItemStack stack, EntityPlayer player, World world, BlockPos pos, EnumFacing side, float hitX, float hitY, float hitZ, IBlockState newState) {
        if (!world.func_180501_a(pos, newState, 11)) return false;

        IBlockState state = world.func_180495_p(pos);
        if (state.func_177230_c() == item.field_150939_a) {
            func_179224_a(world, player, pos, stack);
            TileEntity tile = world.func_175625_s(pos);
            if (tile instanceof TileDynamic)
                setNBT((TileDynamic) tile, world, stack);
            ((BlockDynamic) item.field_150939_a).onBlockPlacedBy(world, pos, state, player, stack, side, hitX, hitY, hitZ);
            if (player instanceof EntityPlayerMP)
                CriteriaTriggers.field_193137_x.func_193173_a((EntityPlayerMP) player, pos, stack);
        }
        return true;
    }

    public static void setNBT(TileDynamic tileentity, World worldIn, ItemStack stackIn) {
        NBTTagCompound data = stackIn.func_179543_a("texture");

        if (data != null) {
            if (tileentity != null) {
                if (!worldIn.field_72995_K && tileentity.func_183000_F()) {
                    return;
                }

                NBTTagCompound tileNBT = tileentity.func_189515_b(new NBTTagCompound());
                NBTTagCompound newNBT = tileNBT.func_74737_b();
                tileNBT.func_179237_a(data);
                if (!tileNBT.equals(newNBT)) {
                    tileentity.func_145839_a(tileNBT);
                    tileentity.func_70296_d();
                }
            }
        }
    }

    public boolean placeBlockAt(@Nonnull ItemStack stack, @Nonnull EntityPlayer player, World world, @Nonnull BlockPos pos, EnumFacing side, float hitX, float hitY, float hitZ, @Nonnull IBlockState newState) {
        return placeBlockAt(this, stack, player, world, pos, side, hitX, hitY, hitZ, newState);
    }

    @Nonnull
    @Override
    public String func_77653_i(@Nonnull ItemStack stack) {
        NBTTagCompound tag = stack.func_179543_a("texture");

        //TODO .name
        ITextComponent type = new TextComponentTranslation("betterwithmods:unknown_mini.name");
        ITextComponent base = new TextComponentTranslation(this.func_77667_c(stack) + ".name");

        if (tag != null) {
            IBlockState state = NBTUtil.func_190008_d(tag);
            ItemStack block = new ItemStack(state.func_177230_c(), 1, state.func_177230_c().func_176201_c(state));
            if (block.func_77973_b() instanceof ItemBlock) {
                ItemBlock itemBlock = (ItemBlock) block.func_77973_b();
                type = new TextComponentString(itemBlock.func_77653_i(block));
            }
        }

        return type.func_150257_a(base).func_150254_d();
    }
}
