package betterwithmods.module.recipes.miniblocks.blocks;

import betterwithmods.common.blocks.camo.BlockDynamic;
import betterwithmods.library.common.block.IRotate;
import betterwithmods.module.recipes.miniblocks.DynamicType;
import betterwithmods.module.recipes.miniblocks.ISubtypeProvider;
import betterwithmods.module.recipes.miniblocks.PropertyOrientation;
import betterwithmods.module.recipes.miniblocks.orientations.IOrientation;
import betterwithmods.module.recipes.miniblocks.tiles.TileOrientation;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.IBlockState;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Optional;

public abstract class BlockOrientation<O extends IOrientation<O> & Comparable<O>, T extends TileOrientation<O>> extends BlockDynamic<T> {

    public abstract PropertyOrientation<O> getOrientationProperty();

    public BlockOrientation(Material material, ISubtypeProvider subtypes) {
        super(material, subtypes);
    }

    @Nullable
    @Override
    public abstract TileEntity createTileEntity(@Nonnull World world, @Nonnull IBlockState state);

    @Override
    public IBlockState func_176221_a(IBlockState state, IBlockAccess worldIn, BlockPos pos) {
        IBlockState actualState = super.func_176221_a(state, worldIn, pos);
        return actualState.func_177226_a(getOrientationProperty(), getOrientation(worldIn, pos));
    }

    @Override
    public IProperty<?>[] getProperties() {
        return new IProperty[]{getOrientationProperty()};
    }

    @Nonnull
    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        IOrientation o = getOrientation(source, pos);
        if (o != null) {
            return o.getBounds();
        }

        return super.func_185496_a(state, source, pos);
    }

    protected O getOrientation(IBlockAccess world, BlockPos pos) {
        if(world.func_180495_p(pos).func_177230_c() instanceof BlockOrientation)
            return getTile(world, pos).map(TileOrientation::getOrientation).orElse(getOrientationProperty().getDefault());
        return null;
    }


    @Override
    public boolean func_176225_a(IBlockState blockState, @Nonnull IBlockAccess world, @Nonnull BlockPos pos, EnumFacing side) {

        O orientation = getOrientation(world,pos);
        if(orientation != null) {
            return true;
//            O neighbor = getOrientation(world,pos.offset(side));
//            if(neighbor != null && orientation != neighbor)
//                return true;
        }
        return super.func_176225_a(blockState, world, pos, side);
    }

    @Override
    public void nextState(World world, BlockPos pos, IBlockState state) {
        Optional<T> t = getTile(world,pos);
        if(t.isPresent()) {
            T tile = t.get();
            tile.setOrientation(tile.getOrientation().next());
            world.func_175704_b(pos,pos);
        }
    }

    @Override
    public boolean rotates() {
        return true;
    }

//    @Override
//    public boolean rotateBlock(World world, @Nonnull BlockPos pos, @Nonnull EnumFacing axis) {
//        nextState(world,pos, world.getBlockState(pos));
//        return true;
//    }
}

