package betterwithmods.module.tweaks;

import betterwithmods.common.BWMItems;
import betterwithmods.common.entity.EntityShearedCreeper;
import betterwithmods.library.common.modularity.impl.Feature;
import betterwithmods.library.utils.EntityUtils;
import betterwithmods.library.utils.InventoryUtils;
import betterwithmods.module.internal.AdvancementRegistry;
import net.minecraft.entity.EntityList;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemShears;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundCategory;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import java.util.Set;

/**
 * Created by primetoxinz on 4/20/17.
 */

public class CreeperShearing extends Feature {

    public static Set<ResourceLocation> CREEPERS;

    private static boolean isMatching(EntityLivingBase entity) {
        return CREEPERS.stream().anyMatch(r -> EntityList.func_180123_a(entity, r));
    }

    @SubscribeEvent
    public void mobDrops(LivingDropsEvent event) {
        EntityLivingBase entity = event.getEntityLiving();
        if (isMatching(entity)) {
            double chance = entity.func_70681_au().nextDouble() + (0.1 * event.getLootingLevel());
            if (chance <= 0.05) {
                EntityUtils.addDrop(event, new ItemStack(BWMItems.CREEPER_OYSTER));
            }
        }
    }

    @SubscribeEvent
    public void shearCreeper(PlayerInteractEvent.EntityInteractSpecific e) {

        if (e.getTarget() instanceof EntityLivingBase) {
            EntityLivingBase creeper = (EntityLivingBase) e.getTarget();
            if (isMatching(creeper)) {
                if (e.getSide().isServer() && creeper.func_70089_S() && !e.getItemStack().func_190926_b()) {
                    Item item = e.getItemStack().func_77973_b();
                    if (item instanceof ItemShears || item.getHarvestLevel(e.getItemStack(), "shear", e.getEntityPlayer(), null) > 0) {
                        if (e.getEntityPlayer().func_184811_cZ().func_185141_a(item))
                            return;
                        e.getEntityPlayer().func_184811_cZ().func_185145_a(item, 20);
                        e.getItemStack().func_77972_a(1, e.getEntityLiving());
                        InventoryUtils.ejectStack(e.getWorld(), creeper.field_70165_t, creeper.field_70163_u, creeper.field_70161_v, new ItemStack(BWMItems.CREEPER_OYSTER));
                        EntityShearedCreeper shearedCreeper = new EntityShearedCreeper(e.getWorld());
                        creeper.func_70097_a(new DamageSource(""), 0);
                        EntityUtils.copyEntityInfo(creeper, shearedCreeper);
                        e.getWorld().func_184148_a(null, shearedCreeper.field_70165_t, shearedCreeper.field_70163_u, shearedCreeper.field_70161_v, SoundEvents.field_187882_fq, SoundCategory.HOSTILE, 1, 0.3F);
                        e.getWorld().func_184148_a(null, shearedCreeper.field_70165_t, shearedCreeper.field_70163_u, shearedCreeper.field_70161_v, SoundEvents.field_187763_eJ, SoundCategory.HOSTILE, 1, 1F);
                        creeper.func_70106_y();
                        e.getWorld().func_72838_d(shearedCreeper);
                        if (e.getEntityPlayer() instanceof EntityPlayerMP) {
                            AdvancementRegistry.trigger((EntityPlayerMP) e.getEntityPlayer(), AdvancementRegistry.SHEAR_CREEPER);
                        }
                    }
                }
            }
        }
    }

    @Override
    public void onInit(FMLInitializationEvent event) {
        CREEPERS = config().loadResourceLocations("Creepers", getCategory(), "List of valid creepers", new String[]{"minecraft:creeper"});
    }

    @Override
    public String getDescription() {
        return "Shearing a Creeper will removes its ability to explode, making him very sad";
    }

    @Override
    public boolean hasEvent() {
        return true;
    }
}
