package betterwithmods.module.tweaks;

import betterwithmods.api.recipe.output.impl.ListOutputs;
import betterwithmods.client.render.RenderLongboi;
import betterwithmods.common.blocks.BlockWolf;
import betterwithmods.common.entity.EntityLongboi;
import betterwithmods.common.registry.block.recipe.TurntableRecipe;
import betterwithmods.lib.ModLib;
import betterwithmods.library.common.block.creation.BlockEntryBuilderFactory;
import betterwithmods.library.common.modularity.impl.Feature;
import betterwithmods.library.utils.EntityUtils;
import betterwithmods.library.utils.ingredient.EntityIngredient;
import betterwithmods.module.internal.BlockRegistry;
import betterwithmods.module.internal.EntityRegistry;
import betterwithmods.module.internal.RecipeRegistry;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.registry.EntityEntryBuilder;

import java.util.Optional;

public class LongBoi extends Feature {

    @Override
    public String getDescription() {
        return "Long Bois!";
    }

    @Override
    public void onPreInitClient(FMLPreInitializationEvent event) {
        RenderingRegistry.registerEntityRenderingHandler(EntityLongboi.class, RenderLongboi::new);
    }

    @Override
    public void onPreInit(FMLPreInitializationEvent event) {
        BlockRegistry.registerBlocks(BlockEntryBuilderFactory.<Void>create(getLogger())
                .builder().block(new BlockWolf(new ResourceLocation(ModLib.MODID, "longboi"))).id("long_friend").build()
                .complete());

        EntityRegistry.registerEntity(
                EntityEntryBuilder.create()
                        .entity(EntityLongboi.class)
                        .name(EntityRegistry.entityName("longboi"))
                        .id(new ResourceLocation(ModLib.MODID, "longboi"), EntityRegistry.TOTAL_ENTITY_IDS++)
                        .tracker(64, 1, true)
                        .egg(0xe4d3d0, 0xfd742b)
                        .build()
        );
        RecipeRegistry.TURNTABLE.register(new LongRecipe());
    }

    private static class LongRecipe extends TurntableRecipe {

        public LongRecipe() {
            super(new EntityIngredient(new ResourceLocation("wolf")), new ListOutputs(), 8, Blocks.field_150350_a.func_176223_P(), ItemStack.field_190927_a);
        }


        @Override
        public NonNullList<ItemStack> onCraft(World world, BlockPos pos) {

            Optional<EntityLivingBase> entity = EntityIngredient.getEntity(world, pos);
            if (entity.isPresent()) {
                EntityLongboi longboi = new EntityLongboi(world);
                EntityUtils.copyEntityInfo(entity.get(), longboi);
                world.func_72838_d(longboi);
                world.func_184133_a(null, pos, SoundEvents.field_187863_gH, SoundCategory.NEUTRAL, 0.75F, 1.0F);
                entity.get().func_70106_y();
            }

            return super.onCraft(world, pos);
        }

        @Override
        public boolean isInvalid() {
            return false;
        }

        @Override
        public boolean isHidden() {
            return true;
        }
    }

}
